GNU bug report logs - #41429
Shepherd Sometimes Crashes

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: guix; Severity: important; Reported by: Katherine Cox-Buday <cox.katherine.e@HIDDEN>; merged with #40981; dated Thu, 21 May 2020 03:00:02 UTC; Maintainer for guix is bug-guix@HIDDEN.
Merged 40981 41429. Request was from Ludovic Courtès <ludo@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Severity set to 'important' from 'normal' Request was from Ludovic Courtès <ludo@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 41429 <at> debbugs.gnu.org:


Received: (at 41429) by debbugs.gnu.org; 22 May 2020 17:39:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri May 22 13:39:32 2020
Received: from localhost ([127.0.0.1]:60306 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jcBds-00029P-Lh
	for submit <at> debbugs.gnu.org; Fri, 22 May 2020 13:39:32 -0400
Received: from eggs.gnu.org ([209.51.188.92]:41738)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <othacehe@HIDDEN>) id 1jcBdq-00029B-0w
 for 41429 <at> debbugs.gnu.org; Fri, 22 May 2020 13:39:31 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:53692)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <othacehe@HIDDEN>)
 id 1jcBdk-00057K-Oc; Fri, 22 May 2020 13:39:24 -0400
Received: from [2a01:e0a:fa:a50:7ced:409d:b570:ed70] (port=54418 helo=meru)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <othacehe@HIDDEN>)
 id 1jcBdX-0001wQ-5R; Fri, 22 May 2020 13:39:23 -0400
From: Mathieu Othacehe <othacehe@HIDDEN>
To: Katherine Cox-Buday <cox.katherine.e@HIDDEN>
Subject: Re: bug#41429: Shepherd Sometimes Crashes
References: <87d06yc7t4.fsf@HIDDEN>
Date: Fri, 22 May 2020 19:39:09 +0200
In-Reply-To: <87d06yc7t4.fsf@HIDDEN> (Katherine Cox-Buday's message of
 "Wed, 20 May 2020 21:59:03 -0500")
Message-ID: <877dx3vphe.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 41429
Cc: 41429 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)


Hello Katherine,

> I'm running `strace` against the Shepherd process in an attempt to
> submit a better bug report, but this is all I have for now. Maybe others
> have also seen this behavior.

Yes, I have observed this behavior. This should be fixed with the
upcoming 0.8.1 release of Shepherd (hopefully !).

See: https://lists.gnu.org/archive/html/bug-guix/2020-05/msg00241.html.

Thanks for reporting,

Mathieu




Information forwarded to bug-guix@HIDDEN:
bug#41429; Package guix. Full text available.

Message received at 41429 <at> debbugs.gnu.org:


Received: (at 41429) by debbugs.gnu.org; 21 May 2020 15:59:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 21 11:59:56 2020
Received: from localhost ([127.0.0.1]:57145 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jbnbw-0006Bm-8k
	for submit <at> debbugs.gnu.org; Thu, 21 May 2020 11:59:56 -0400
Received: from mail-io1-f44.google.com ([209.85.166.44]:42469)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <cox.katherine.e@HIDDEN>) id 1jbnbt-0006BX-8Q
 for 41429 <at> debbugs.gnu.org; Thu, 21 May 2020 11:59:54 -0400
Received: by mail-io1-f44.google.com with SMTP id e18so7938516iog.9
 for <41429 <at> debbugs.gnu.org>; Thu, 21 May 2020 08:59:53 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=NggpimCG87oy8hK9I5f6aL7wqAg7F8zqjBJDatxRDGs=;
 b=HQammI1SYWdkk7W9I47adCs9WNVAZElgVKRU/fbjIhhpnMTlIvNdX74nL4UdcFY0my
 vRoGRxtzKSnTLrgLEwTQWVc2kPfMgnGrZmeOn+nHtp6bmOKcbu152CcAOqueI/oJiPv+
 4NtJRn56n1rJuxjuR/ja8lWsvH/ntiaialaSQ7NDLRNYGcB71v0+J0yIy9qjd0YpSLYN
 noWqhVrXuJDqqn8bEryyeTHNJ41FNGuYAAu/KZV9RtEu1OM9x/o5vDyfNnJoUbOWd9/x
 YC0nQEQM/yvw3/nd7C8ROeNH0AvYxAt6nNi9SiY+/HNS2HnbTYrvh6zLmdhqHVjxqfVd
 FGKg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=NggpimCG87oy8hK9I5f6aL7wqAg7F8zqjBJDatxRDGs=;
 b=OTWRZT0U6no713rWmKK65rrEFDBTrsJ+z5JOmDYR3DzJROls3igewWfR/F6H8b1ai7
 fbIUSdA3mtMAdT7bFjDyDjfMlT8mvsX85Kg7sVGHZFkqlTr5QVhvZaIb1uGgeTh7lFIc
 +tDqx4RMq9CyjkeV/8NYLmX4pC9+g91bUu09x6FRdX5P+If42DwXjeC+mvVUuxh5Mgi+
 nv6dwr4yIRvqvjqyr068HVmRk+LxGdqxW1jorIXk0K5QrI5r/dYXsTyct+RooKXq2b7H
 ktYWX0JD/e5YRdFZUCTgSZRP037Yf1yf1pASb9ERpa44eo9B+EhAgEk0pD8qlyyqSHxg
 Jw9Q==
X-Gm-Message-State: AOAM5326G+cjl5UQ5JfbZP8Mu/VOI2NO50pDqFHNbJjarWF22TS4Nda9
 IXIIGAc13sQWeye5JzTUtylfDJee
X-Google-Smtp-Source: ABdhPJym9S0IWE6oJ9ICEtZcgfYMVbLQS3kKQf6R/FqBwPcQO7Ojpt1zp8W1PP+bdncmvL8h4BI1Cg==
X-Received: by 2002:a6b:7b42:: with SMTP id m2mr7670360iop.98.1590076785480;
 Thu, 21 May 2020 08:59:45 -0700 (PDT)
Received: from gazelle-pro (172-221-246-205.res.spectrum.com.
 [172.221.246.205])
 by smtp.gmail.com with ESMTPSA id a13sm3301271ill.34.2020.05.21.08.59.44
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 21 May 2020 08:59:44 -0700 (PDT)
From: Katherine Cox-Buday <cox.katherine.e@HIDDEN>
To: Efraim Flashner <efraim@HIDDEN>
Subject: Re: bug#41429: Shepherd Sometimes Crashes
References: <87d06yc7t4.fsf@HIDDEN> <20200521121443.GC958@E5400>
 <87sgftbgd1.fsf@HIDDEN> <20200521140442.GF958@E5400>
Date: Thu, 21 May 2020 10:59:43 -0500
In-Reply-To: <20200521140442.GF958@E5400> (Efraim Flashner's message of "Thu, 
 21 May 2020 17:04:42 +0300")
Message-ID: <87k115b7o0.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 41429
Cc: 41429 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Efraim Flashner <efraim@HIDDEN> writes:

>> Your comment is kind of scary though! Shepherd is the thing I want to
>> stay up no matter what since it's responsible for monitoring and
>> restarting things. The idea that a misbehaving or poorly written service
>> could bring down the entire Shepherd process is a problem! Is there no
>> isolation?
>
> I have a whole collection of attempts to integrate mcron with shepherd,
> to create loops and add jobs only when the service is active. Attempting
> to fork off and then collect the child process and then fail just enough
> to make the service restart. Lots of cringe-worthy code. The more common
> fail scenarios I see are shepherd fails to start because it doesn't like
> my start code of one of the services or actually starting the service
> somehow kills it. All of those were with straight lambdas to the start
> command though.

I'm not familiar with Shepherd's internals, so I don't know why
interacting with a cron is relevant.

> Do you have your services writing out any logs? Maybe there's a clue
> there.

Not yet, but I should be enabling this soon, and if they display
anything I'll report back.

Still, this seems beside the point: the bug is that Shepherd needs to
stay up regardless of what the services it's monitoring do.

-- 
Katherine




Information forwarded to bug-guix@HIDDEN:
bug#41429; Package guix. Full text available.

Message received at 41429 <at> debbugs.gnu.org:


Received: (at 41429) by debbugs.gnu.org; 21 May 2020 14:05:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 21 10:05:24 2020
Received: from localhost ([127.0.0.1]:57032 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jblp5-0003Te-OH
	for submit <at> debbugs.gnu.org; Thu, 21 May 2020 10:05:24 -0400
Received: from flashner.co.il ([178.62.234.194]:42726)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <efraim@HIDDEN>) id 1jblp3-0003TK-70
 for 41429 <at> debbugs.gnu.org; Thu, 21 May 2020 10:05:21 -0400
Received: from localhost (unknown [188.120.128.132])
 by flashner.co.il (Postfix) with ESMTPSA id DFBD54025B;
 Thu, 21 May 2020 14:05:14 +0000 (UTC)
Date: Thu, 21 May 2020 17:04:42 +0300
From: Efraim Flashner <efraim@HIDDEN>
To: Katherine Cox-Buday <cox.katherine.e@HIDDEN>
Subject: Re: bug#41429: Shepherd Sometimes Crashes
Message-ID: <20200521140442.GF958@E5400>
References: <87d06yc7t4.fsf@HIDDEN> <20200521121443.GC958@E5400>
 <87sgftbgd1.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; micalg=pgp-sha512;
 protocol="application/pgp-signature"; boundary="vA66WO2vHvL/CRSR"
Content-Disposition: inline
In-Reply-To: <87sgftbgd1.fsf@HIDDEN>
X-PGP-Key-ID: 0x41AAE7DCCA3D8351
X-PGP-Key: https://flashner.co.il/~efraim/efraim_flashner.asc
X-PGP-Fingerprint: A28B F40C 3E55 1372 662D  14F7 41AA E7DC CA3D 8351
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 41429
Cc: 41429 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


--vA66WO2vHvL/CRSR
Content-Type: text/plain; charset=utf-8
Content-Disposition: inline
Content-Transfer-Encoding: quoted-printable

On Thu, May 21, 2020 at 07:51:54AM -0500, Katherine Cox-Buday wrote:
> Efraim Flashner <efraim@HIDDEN> writes:
>=20
> > On Wed, May 20, 2020 at 09:59:03PM -0500, Katherine Cox-Buday wrote:
> >> I am running shepherd as a userspace service manager on an alien distr=
o.
> >> Occassionally (often enough as to cause concern), Shepherd is crashing.
> >> I am unable to narrow down a cause, but anecdotally, it seems to happen
> >> more often when a service it's managing fails repeatedly and is
> >> disabled.
> >>=20
> >> I'm running `strace` against the Shepherd process in an attempt to
> >> submit a better bug report, but this is all I have for now. Maybe othe=
rs
> >> have also seen this behavior.
> >
> > I found it happens less often with shepherd-0.8. What version are you
> > running? Also possibly related, do you have mismatched versions of guile
> > between guix packages and your distro's native packages?
>=20
> Sorry, I forgot to include the version! I am running 0.8 from a store
> which I update ~1 week.
>=20
> > I've also sometimes found shepherd to crash when I add a service where
> > the start command is "wrong", as though the error were so bad that
> > shepherd says "Nope! That's it! I quit!"
>=20
> I'm doing very standard things with `make-forkexec-constructor`, so I
> wouldn't expect any problems there.
>=20
> Your comment is kind of scary though! Shepherd is the thing I want to
> stay up no matter what since it's responsible for monitoring and
> restarting things. The idea that a misbehaving or poorly written service
> could bring down the entire Shepherd process is a problem! Is there no
> isolation?

I have a whole collection of attempts to integrate mcron with shepherd,
to create loops and add jobs only when the service is active. Attempting
to fork off and then collect the child process and then fail just enough
to make the service restart. Lots of cringe-worthy code. The more common
fail scenarios I see are shepherd fails to start because it doesn't like
my start code of one of the services or actually starting the service
somehow kills it. All of those were with straight lambdas to the start
command though.

Do you have your services writing out any logs? Maybe there's a clue
there.

> > I'd suggest looking at .config/shepherd/shepherd.log but it's rather
> > sparse. Still, it might have something useful.
>=20
> Yes, this is the first place I looked, but unfortunately there wasn't
> much usable informatino.
>=20
> --=20
> Katherine

--=20
Efraim Flashner   <efraim@HIDDEN>   =D7=90=D7=A4=D7=A8=D7=99=D7=9D =
=D7=A4=D7=9C=D7=A9=D7=A0=D7=A8
GPG key =3D A28B F40C 3E55 1372 662D  14F7 41AA E7DC CA3D 8351
Confidentiality cannot be guaranteed on emails sent or received unencrypted

--vA66WO2vHvL/CRSR
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAABCgAdFiEEoov0DD5VE3JmLRT3Qarn3Mo9g1EFAl7GinYACgkQQarn3Mo9
g1E7Zw/+L2CA+Yy0ewq6WgTq+CmcVRUju6X9PvR8Od1Q6QxWKl4p0xdcJjI21OKt
uSz0OmoM+cZRud7EZtXpbRds1k4ar6ZmM9pJv5WUBZaF11kISrxjJnncbEsHCy0U
NwIEp4OSiZRubBiBzST7Wb9fr3XZSK4rvuSqmr+9OPKkj6ekZcIa51PG7h2wODyn
2gjqYdfXoKXxCB7RECRPw7v92k6QGuqnSAXlwi9fNg1ZojFECelaL0b4liqb23wG
AbJ4HmatBagLo5TezO9g6KdhxS3VfEvqsuN1h6JwHXCYoAJsfN3HN9R8KovNf/Wi
mL+WIxq0FpRX5rexV7GkZaC86ABGspxmrbPnnqPktCqjwwMHPo4iFeHIIzx1w9VM
PPzAg3Da2TilkR5z0h4Td+nKNvCjSQ6C6WZhlxaG/uOSPYSSBApbYWgRg81x+xq6
m11UroqNSQ34PekPhl7u1Bowillyd1OvK1tIi8as7i6DEEFzsjRafP+cfZa0apkt
9LGPYXjL/me4y9ZWhXnF3gYA32lCKdyCIphLr2iJvppA44wubMsG7piE1HPkBzTm
GxkdHgS1qrVW8ucYgw9KVLiB3DxwY5a3RP4jBjPx/GBNZ+bq5DKG4c58CuZZmIF2
Z4hCU448pYKS6mFGgCUCdalPeFF6u219tTiB7XprcXKhmuhEKFA=
=GPjE
-----END PGP SIGNATURE-----

--vA66WO2vHvL/CRSR--




Information forwarded to bug-guix@HIDDEN:
bug#41429; Package guix. Full text available.

Message received at 41429 <at> debbugs.gnu.org:


Received: (at 41429) by debbugs.gnu.org; 21 May 2020 12:52:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 21 08:52:06 2020
Received: from localhost ([127.0.0.1]:55576 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jbkg7-0001Gl-Ho
	for submit <at> debbugs.gnu.org; Thu, 21 May 2020 08:52:06 -0400
Received: from mail-il1-f171.google.com ([209.85.166.171]:38832)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <cox.katherine.e@HIDDEN>) id 1jbkg6-0001GG-8i
 for 41429 <at> debbugs.gnu.org; Thu, 21 May 2020 08:52:02 -0400
Received: by mail-il1-f171.google.com with SMTP id j2so6948638ilr.5
 for <41429 <at> debbugs.gnu.org>; Thu, 21 May 2020 05:52:02 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=218tO2+INfz4QNm95jZJmOH3sfNEeT/JW/6z9Kkl0k8=;
 b=AZ0BrJAk97trGRb3dzP4P2/g5l/ilyfgJWXyZhtlzahK38GglUlLdJgT6ltAk/z7ub
 K4VhbklrSsGtGlHvdqckZpwtl+2VVs7cNQDVGbnipy0pNhHeKk6dyB3VIdcDaLNxrX5k
 H7Efs3r9VHL/Q3ykvchO8e+w+8NfrfLU73ILQV/47rjy4AYcsh6rlNk0FNDkD6QKeLQg
 WQjb3apq+sugIrd9D/TXP/Ye/K1HkhogA56Tqfv9HxMkfCieThdzaqdfD4Qk4+S18hbC
 tTgy7aTezDx9LEW8ySyX8NDEe6KnlNukYMmY52c36CuiO6/AYHNjdqlsse8WJuoA8Zel
 Twmg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=218tO2+INfz4QNm95jZJmOH3sfNEeT/JW/6z9Kkl0k8=;
 b=cgFQeH4l/bqMUtMWV+vqCdErsZgNt3KhrQlYdvTuYdj8onZ3DWp60brlMTRBFbaT3/
 Csa4m+TKOV1FMDrotGr7Lr7ZNvtNKfTF89AYggrbDXhWQBtSwhcd8jYC9A2Xp5j/B0xM
 ov3hceqnXh7MOZUJiQUxzm7L7FCfVycagwwowgqfHUXkeEt/7YjUqNhGvhaVsjdgHjyB
 /jYp+ycqrxGlhazQtNrBlFQDta7wL+Kd1llxLhYska8eVrc0g1vdm4gApmD5KXypAwjf
 PwxKVkkNVPxPRq8nAHLn1AQmOlNGUV7g1+vEvaM3au0YLtqMERtxiUEvk/Wz3CrO+s04
 4E6Q==
X-Gm-Message-State: AOAM532m3cqbxmRUvdIqtc1rBXH2euqNLW1ByWLWjzYmWQENnEiesFNn
 2Lpry+nG/S/747oaEFBQRA0+HwFz
X-Google-Smtp-Source: ABdhPJyr95rVmj4CaOXC0fzzG7tIpKgjxc4e5yrfNmhG/lkyZJLi7QEotDg9VSpQTqel5dxoI1yjVQ==
X-Received: by 2002:a92:3954:: with SMTP id g81mr8648442ila.105.1590065516037; 
 Thu, 21 May 2020 05:51:56 -0700 (PDT)
Received: from gazelle-pro (172-221-246-205.res.spectrum.com.
 [172.221.246.205])
 by smtp.gmail.com with ESMTPSA id i15sm2891226ils.74.2020.05.21.05.51.54
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 21 May 2020 05:51:55 -0700 (PDT)
From: Katherine Cox-Buday <cox.katherine.e@HIDDEN>
To: Efraim Flashner <efraim@HIDDEN>
Subject: Re: bug#41429: Shepherd Sometimes Crashes
References: <87d06yc7t4.fsf@HIDDEN> <20200521121443.GC958@E5400>
Date: Thu, 21 May 2020 07:51:54 -0500
In-Reply-To: <20200521121443.GC958@E5400> (Efraim Flashner's message of "Thu, 
 21 May 2020 15:14:43 +0300")
Message-ID: <87sgftbgd1.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 41429
Cc: 41429 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Efraim Flashner <efraim@HIDDEN> writes:

> On Wed, May 20, 2020 at 09:59:03PM -0500, Katherine Cox-Buday wrote:
>> I am running shepherd as a userspace service manager on an alien distro.
>> Occassionally (often enough as to cause concern), Shepherd is crashing.
>> I am unable to narrow down a cause, but anecdotally, it seems to happen
>> more often when a service it's managing fails repeatedly and is
>> disabled.
>> 
>> I'm running `strace` against the Shepherd process in an attempt to
>> submit a better bug report, but this is all I have for now. Maybe others
>> have also seen this behavior.
>
> I found it happens less often with shepherd-0.8. What version are you
> running? Also possibly related, do you have mismatched versions of guile
> between guix packages and your distro's native packages?

Sorry, I forgot to include the version! I am running 0.8 from a store
which I update ~1 week.

> I've also sometimes found shepherd to crash when I add a service where
> the start command is "wrong", as though the error were so bad that
> shepherd says "Nope! That's it! I quit!"

I'm doing very standard things with `make-forkexec-constructor`, so I
wouldn't expect any problems there.

Your comment is kind of scary though! Shepherd is the thing I want to
stay up no matter what since it's responsible for monitoring and
restarting things. The idea that a misbehaving or poorly written service
could bring down the entire Shepherd process is a problem! Is there no
isolation?

> I'd suggest looking at .config/shepherd/shepherd.log but it's rather
> sparse. Still, it might have something useful.

Yes, this is the first place I looked, but unfortunately there wasn't
much usable informatino.

-- 
Katherine




Information forwarded to bug-guix@HIDDEN:
bug#41429; Package guix. Full text available.

Message received at 41429 <at> debbugs.gnu.org:


Received: (at 41429) by debbugs.gnu.org; 21 May 2020 12:15:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 21 08:15:23 2020
Received: from localhost ([127.0.0.1]:55516 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jbk6c-0000OL-W3
	for submit <at> debbugs.gnu.org; Thu, 21 May 2020 08:15:23 -0400
Received: from flashner.co.il ([178.62.234.194]:42546)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <efraim@HIDDEN>) id 1jbk6b-0000O6-TB
 for 41429 <at> debbugs.gnu.org; Thu, 21 May 2020 08:15:22 -0400
Received: from localhost (unknown [188.120.128.132])
 by flashner.co.il (Postfix) with ESMTPSA id C14824025B;
 Thu, 21 May 2020 12:15:15 +0000 (UTC)
Date: Thu, 21 May 2020 15:14:43 +0300
From: Efraim Flashner <efraim@HIDDEN>
To: Katherine Cox-Buday <cox.katherine.e@HIDDEN>
Subject: Re: bug#41429: Shepherd Sometimes Crashes
Message-ID: <20200521121443.GC958@E5400>
References: <87d06yc7t4.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; micalg=pgp-sha512;
 protocol="application/pgp-signature"; boundary="da4uJneut+ArUgXk"
Content-Disposition: inline
In-Reply-To: <87d06yc7t4.fsf@HIDDEN>
X-PGP-Key-ID: 0x41AAE7DCCA3D8351
X-PGP-Key: https://flashner.co.il/~efraim/efraim_flashner.asc
X-PGP-Fingerprint: A28B F40C 3E55 1372 662D  14F7 41AA E7DC CA3D 8351
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 41429
Cc: 41429 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


--da4uJneut+ArUgXk
Content-Type: text/plain; charset=utf-8
Content-Disposition: inline
Content-Transfer-Encoding: quoted-printable

On Wed, May 20, 2020 at 09:59:03PM -0500, Katherine Cox-Buday wrote:
> I am running shepherd as a userspace service manager on an alien distro.
> Occassionally (often enough as to cause concern), Shepherd is crashing.
> I am unable to narrow down a cause, but anecdotally, it seems to happen
> more often when a service it's managing fails repeatedly and is
> disabled.
>=20
> I'm running `strace` against the Shepherd process in an attempt to
> submit a better bug report, but this is all I have for now. Maybe others
> have also seen this behavior.

I found it happens less often with shepherd-0.8. What version are you
running? Also possibly related, do you have mismatched versions of guile
between guix packages and your distro's native packages?

I've also sometimes found shepherd to crash when I add a service where
the start command is "wrong", as though the error were so bad that
shepherd says "Nope! That's it! I quit!"

I'd suggest looking at .config/shepherd/shepherd.log but it's rather
sparse. Still, it might have something useful.

--=20
Efraim Flashner   <efraim@HIDDEN>   =D7=90=D7=A4=D7=A8=D7=99=D7=9D =
=D7=A4=D7=9C=D7=A9=D7=A0=D7=A8
GPG key =3D A28B F40C 3E55 1372 662D  14F7 41AA E7DC CA3D 8351
Confidentiality cannot be guaranteed on emails sent or received unencrypted

--da4uJneut+ArUgXk
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAABCgAdFiEEoov0DD5VE3JmLRT3Qarn3Mo9g1EFAl7GcLAACgkQQarn3Mo9
g1HBrRAAo8tkuKQq8iFEDcca1Ns2wBjX/YkRMxZ0YKdjNQbUtAwwX/C58fNhBbEx
6azwrBPcgM2UNs5h5BZf5pCNbNgwUvz5FI+X7fpoXuSD7kc6MHQZSePy7rAyQV/t
8sAjUgBDeojp2fMZ/BryWrmnvFNJzXQy1bItUZRwfVm3xVdwrXwyFQbxslOpvves
wmysubdsu+lQZfbyNYyw5JFYhiIqk+Gzel0OwKCVayg36qGMlywyJnlyO2tW65uP
6R07Cv/BB4o2ho05p9R1nd8acHBViZscGr/5oaaWQcnIi9ci5FT6Oo/I8yQqF45f
0bXEZXmMn9NpChT8IGWePX8L2zCLXDXJPmb5khHxx4uSXBl0VRNBbAOtVKJPfSk1
kOWbjZEz4Qv/cpHJnUYRgooNJ0sl4LvHQeQLw2jH1Kwr3/9AO6mfSaaB8gN+l9ET
TyWpkRSQkBaH4f3Lu4sMJUoW3A0LgDTvcDuXEkOMaNZd2vgYOt4KucBtDH/1FfUE
UT9ZFolDxKTZmtztZNHl5bysj/6Gn6kRoFbL+z2JJH/BZQyccH72YRmY+dYZdzdW
xDcPp2IE1aTmeZxNgaiNv6r4UK+alTMOFWKWiQUJ3+NpIMxwU+HezKu1r2Ji5BlW
6Ojw9Hj2W5qxRTlf4mCTnKTEX8jYmZfQaCXyLAPxPvbRtzSQmEU=
=G/Uj
-----END PGP SIGNATURE-----

--da4uJneut+ArUgXk--




Information forwarded to bug-guix@HIDDEN:
bug#41429; Package guix. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 21 May 2020 02:59:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed May 20 22:59:13 2020
Received: from localhost ([127.0.0.1]:54871 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jbbQO-0007cN-S8
	for submit <at> debbugs.gnu.org; Wed, 20 May 2020 22:59:13 -0400
Received: from lists.gnu.org ([209.51.188.17]:46718)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <cox.katherine.e@HIDDEN>) id 1jbbQM-0007cF-0N
 for submit <at> debbugs.gnu.org; Wed, 20 May 2020 22:59:11 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:49062)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <cox.katherine.e@HIDDEN>)
 id 1jbbQL-0004Yy-OD
 for bug-guix@HIDDEN; Wed, 20 May 2020 22:59:09 -0400
Received: from mail-il1-x12e.google.com ([2607:f8b0:4864:20::12e]:40929)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.90_1) (envelope-from <cox.katherine.e@HIDDEN>)
 id 1jbbQL-0002Yy-21
 for bug-guix@HIDDEN; Wed, 20 May 2020 22:59:09 -0400
Received: by mail-il1-x12e.google.com with SMTP id m6so5577656ilq.7
 for <bug-guix@HIDDEN>; Wed, 20 May 2020 19:59:08 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:date:message-id:user-agent:mime-version;
 bh=+BQoA1gop/A0zUHohdUmu2BpMqUKv3fG0kflk5bRKVM=;
 b=BBkAO5b3IFndtOmQBvswc1lQDHGC7zWhdYe5E5YeH0gtuoVUaaCLirt6KgguBF1EvY
 QJUVGW9jeNsQfOJCkkwBRJmBeSQbKLqZJmMQ2lkG9lQTnbhhVNXSOIJE+y7vCFziOdGF
 4ZtregcHWbSgQt4WaejcdnvlCcm8IRYOisvSFRJnq3QfAaC/Xq1f3zgYJfhaw5TKwm65
 gLXHaZhc6hkDaB0/AYJAMicBG4EspNq5n/JSqNLyA+eOZCvx9A6vl0j+0nbaYaycPyAd
 DwdgdhrD4QdX7+PTgdNdOy99t7PJnufjTSQtcXecXDIzeakjMarUYcAv/0pOSvjodYH7
 Ze+Q==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:message-id:user-agent
 :mime-version;
 bh=+BQoA1gop/A0zUHohdUmu2BpMqUKv3fG0kflk5bRKVM=;
 b=Qp5kJwVNTfAbVwnhRpj4ns01bw1IB+O846m72cJomnYtvHibRcTr/yO7oLYz8aTRjE
 CSdA0+RMg04Vhih4p6Igl4o+4+HC5VYwSciOyicnMy/ovJTHmX8pOZ3Q6oigzq8sPysb
 WqKSmja3hCYN0cSA69OE11Ml3sJrATbHkhOmi0GdNDgR/MDeHyDIKw03ceDZheY2zl+q
 MK4di1x7KjiuN6VPDHHiPCLiZZdQkqoFHbmNNoKjDYwRtESXVaSMQLmVZxKAL4KhriLd
 +/SLkfaLACTzqgmiuHKxV8b44mQ32EJCl+qFpJvQJI7Z3qvq3ud1PP9gVk0oWvtKt/tH
 bxrw==
X-Gm-Message-State: AOAM532VrsiKCmyRN4RqYoCQzBeACsrbKAHmNWcJDcLkEj3Irv1T4I5d
 om3Moc0maonLZf9SELwFscLaOsYD
X-Google-Smtp-Source: ABdhPJwwP58j2bM1Al5lCmT5EFwEIo8VuIUUEhSlWVgFtMsOfJgP1BaK0QnlbFgpwYyLv55tDsF1yQ==
X-Received: by 2002:a92:9e16:: with SMTP id q22mr6602626ili.17.1590029946218; 
 Wed, 20 May 2020 19:59:06 -0700 (PDT)
Received: from gazelle-pro (172-221-246-205.res.spectrum.com.
 [172.221.246.205])
 by smtp.gmail.com with ESMTPSA id t22sm1858730iom.49.2020.05.20.19.59.03
 for <bug-guix@HIDDEN>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Wed, 20 May 2020 19:59:04 -0700 (PDT)
From: Katherine Cox-Buday <cox.katherine.e@HIDDEN>
To: bug-guix@HIDDEN
Subject: Shepherd Sometimes Crashes
Date: Wed, 20 May 2020 21:59:03 -0500
Message-ID: <87d06yc7t4.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
Received-SPF: pass client-ip=2607:f8b0:4864:20::12e;
 envelope-from=cox.katherine.e@HIDDEN; helo=mail-il1-x12e.google.com
X-detected-operating-system: by eggs.gnu.org: No matching host in p0f cache.
 That's all we know.
X-Spam_score_int: -20
X-Spam_score: -2.1
X-Spam_bar: --
X-Spam_report: (-2.1 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, FREEMAIL_FROM=0.001,
 RCVD_IN_DNSWL_NONE=-0.0001, SPF_PASS=-0.001 autolearn=_AUTOLEARN
X-Spam_action: no action
X-Spam-Score: 0.7 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

I am running shepherd as a userspace service manager on an alien distro.
Occassionally (often enough as to cause concern), Shepherd is crashing.
I am unable to narrow down a cause, but anecdotally, it seems to happen
more often when a service it's managing fails repeatedly and is
disabled.

I'm running `strace` against the Shepherd process in an attempt to
submit a better bug report, but this is all I have for now. Maybe others
have also seen this behavior.

-- 
Katherine




Acknowledgement sent to Katherine Cox-Buday <cox.katherine.e@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-guix@HIDDEN. Full text available.
Report forwarded to bug-guix@HIDDEN:
bug#41429; Package guix. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Fri, 22 May 2020 20:30:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.